if (heapSize < 20000000) then
	heapSize = 200000000
clearlistener()

-- fsource = GetOpenFileName \
-- caption:"The Godfather" \
-- types: "The Godfather (*.str)|*.str|All files (*.*)|*.*|"
-- f = fopen fsource "rb"
-- fext=getFilenameType fsource
-- fpath=getFilenamePath fsource
-- fsize=getFileSize fsource
-- fname=getFilenameFile fsource

f = fopen "H:\\_DEVELOPING\\_google_disc_sync\\TosykDev\\format_research\\division\\_sample\\ca_hem_01.mmb" "rb"

fn readHalfFloat fstream =
	(
		hf=readshort fstream #unsigned
		sign = bit.get hf 16
		exponent = (bit.shift (bit.and hf (bit.hexasint "7C00")) -10) as integer - 16
		fraction = bit.and hf (bit.hexasint "03FF")
		if sign==true then sign = 1 else sign = 0
		exponentF = exponent + 127
		outputAsFloat = bit.or (bit.or (bit.shift fraction 13) \
		(bit.shift exponentF 23)) (bit.shift sign 31)
		return bit.intasfloat outputasfloat*2
    )

fn readFixedString bstream fixedLen =
	(
		local str = ""
		for i = 1 to fixedLen do (
		str += bit.intAsChar (ReadByte bstream #unsigned))
		str
	)

meshFVFInfoArray=#()

for header = 1 to 1 do
	(
		fformat = ReadFixedString f 3; Print ("File Format: "+(fformat)as string)
		fversion = readbyte f; Print ("File Version: "+(fversion)as string)
		fSize = readlong f; Print ("File Size: "+(fSize)as string)
		BnCount = readlong f; Print ("BnCount: "+(BnCount)as string)
	)

for i = 1 to (BnCount) do
	(
		BnNameSize = readshort f
		BnNameName = ReadFixedString f BnNameSize--; Print ("BnNameName: "+(BnNameName)as string)
		boneMat = readfloat f
		fseek f 0x10 #seek_cur
		readfloat f
		fseek f 0x10 #seek_cur
		readfloat f
		null = readlong f
		readfloat f
		fseek f 0x8 #seek_cur
		readlong f
		boneParentID = readshort f--; Print ("boneParentID: "+(boneParentID)as string)
	)

for MeshDetails = 1 to 1 do
	(
		MeshCount = readlong f
		-- Print ("End Here @ 0x"+((bit.intAsHex(ftell f))as string))
		MeshNameSize = readshort f
		MeshName = ReadFixedString f MeshNameSize; Print ("MeshName: "+(MeshName)as string)
		fseek f 0x30 #seek_cur
	)

for fVerChecker = 1 to 1 do
	(
		if fversion == 9 do
			(
				meshUnk00 = readbyte f
			)

		if fversion == 10 OR fversion == 11 do
			(
				meshUnk00 = readshort f
			)
	)

for unk0 = 1 to 1 do
	(
		meshVertComponentCount = readshort f
			
		for i = 1 to (meshVertComponentCount) do
			(
				readshort f
				readbyte f
				readbyte f
			)

		append meshFVFInfoArray meshVertComponentCount
		--Print ("meshVertComponentCount End Here @ 0x"+((bit.intAsHex(ftell f))as string))

		meshNumUnk00 = readshort f; Print ("meshNumUnk00: "+(meshNumUnk00)as string)
		fseek f ((meshNumUnk00)*66) #seek_cur

		meshNumGroups = readbyte f; Print ("meshNumGroups: "+(meshNumGroups)as string)
	)

for i = 1 to (meshNumGroups) do
	(
		if fversion == 9 OR fversion == 10 do
			(
				fseek f 0x40 #seek_cur
			)

		if fversion == 11 do
			(
				fseek f 0x28 #seek_cur
			)
	)

for meshinfo = 1 to 1 do
	(
		fseek f 12 #seek_cur
		meshNumUnk02 = readbyte f; Print ("meshNumUnk02: "+(meshNumUnk02)as string)
		fseek f ((meshNumUnk02)*4) #seek_cur

		unkShort1 = readshort f; Print ("unkShort1: "+(unkShort1)as string)
		unkShort2 = readshort f; Print ("unkShort2: "+(unkShort2)as string)
		unkShort3 = readshort f; Print ("unkShort3: "+(unkShort3)as string)
		unkShort4 = readshort f; Print ("unkShort4: "+(unkShort4)as string)
		unkLong1 = readlong f; Print ("unkLong1: "+(unkLong1)as string)
		unkLong2 = readlong f; Print ("unkLong2: "+(unkLong2)as string)
		offsetTilEnd = readlong f; Print ("offsetTilEnd: "+(offsetTilEnd)as string)
	)

Print ("End Here @ 0x"+((bit.intAsHex(ftell f))as string))
	
fclose f